#include "BFigPrimPolygonSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BFigPrimPolygonSeg::BFigPrimPolygonSeg():
BSegment(TS_FPRIM,TSS_FPRIMPOLYGON)
{
}

UQBYTE BFigPrimPolygonSeg::getLength() const
{
    return 12+pt.size()*4;
}

bool BFigPrimPolygonSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    readSubID(ain);
    if(!ain->read(l_atr))
	return false;
    if(!ain->read(l_pat))
	return false;
    if(!ain->read(f_pat))
	return false;
    if(!ain->read(round))
	return false;
    UDBYTE np;
    if(!ain->read(np))
	return false;
    for(int i=0; i<np; i++)
    {
	POINT p;
	if(!ain->read(p))
	    return false;
	pt.push_back(p);
    }
    return true;
}

bool BFigPrimPolygonSeg::writeData(BByteOutputStream* aout) const
{
    writeSubID(aout);
    if(!aout->write(l_atr))
	return false;
    if(!aout->write(l_pat))
	return false;
    if(!aout->write(f_pat))
	return false;
    if(!aout->write(round))
	return false;
    UDBYTE np=pt.size();
    if(!aout->write(np))
	return false;
    for(int i=0; i<np; i++)
    {
	if(!aout->write(pt[i]))
	    return false;
    }
    return true;
}
