#include "BInfoSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

#include <algo.h>

BInfoSeg::BInfoSeg():
BSegment(TS_INFO)
{
}

BInfoSeg::~BInfoSeg()
{
    vector<BInfoSegData >::iterator i;

    for(i=info.begin(); i!=info.end(); i++)
	delete (*i).data;
}

UQBYTE BInfoSeg::getLength() const
{
    UQBYTE length=0;
    vector<BInfoSegData >::const_iterator i;

    for(i=info.begin(); i!=info.end(); i++)
	length+= (*i).subLen + sizeof(UDBYTE)*2;

    return length;
}

bool BInfoSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    int readSize=0;

    while(alength>readSize)
    {
	BInfoSegData infoData;

	if(!(ain->read(infoData.subID)))
	    return false;
	if(!(ain->read(infoData.subLen)))
	    return false;

	infoData.data=new UDBYTE[infoData.subLen/2];

	for(int i=0; i<infoData.subLen/2; i++)
	    if(!(ain->read(infoData.data[i])))
		return false;

	readSize+=sizeof(infoData.subID)+sizeof(infoData.subLen)+
	          infoData.subLen;
	addBInfoSegData(infoData);
    }
    return true;
}

bool BInfoSeg::writeData(BByteOutputStream* aout) const
{
    vector<BInfoSegData>::const_iterator infoData;

    for(infoData=info.begin(); infoData!=info.end(); infoData++)
    {
	if(!aout->write((*infoData).subID))
	    return false;
	if(!aout->write((*infoData).subLen))
	    return false;
	for(int i=0; i<(*infoData).subLen/2; i++)
	    if(!aout->write((*infoData).data[i]))
		return false;
    }

    return true;
}

class EqualVersion{
public:
    bool operator() (const BInfoSeg::BInfoSegData x) const
    {
	return x.subID==0;
    }
};

UDBYTE BInfoSeg::getVersion()
{
    vector<BInfoSeg::BInfoSegData>::iterator version=
	find_if(info.begin(),info.end(),EqualVersion());
    if(version!=info.end())
	return ((*version).data)[0];
    else
	return 0;
}

void BInfoSeg::setVersion(UDBYTE aversion)
{
    vector<BInfoSegData>::iterator version=
	find_if(info.begin(),info.end(),EqualVersion());
    if(version!=info.end())
	((*version).data)[0]=aversion;
    else{
	BInfoSegData version;
	version.subID=0;
	version.subLen=2;
	version.data=new UDBYTE;
	*(version.data)=aversion;
	addBInfoSegData(version);
    }
}    
