#include "BTADType.h"
#include "BTADInputHelper.h"
#include "BSegment.h"
#include "BByteInputStream.h"
#include "BSegmentMaker.h"
#include "BStringSeg.h"

BTADInputHelper::BTADInputHelper(BByteInputStream* ain,BSegmentMaker* amaker):
in(ain),maker(amaker)
{
}

bool BTADInputHelper::readID(BYTE& aID)
{
    BYTE buf[2];

    if(in->peek(2,buf)!=2)
	return false;

    if(buf[1]==0xff && 0x80 <=buf[0] && buf[0] <=0xfe)
    {
	in->skip(2);
	aID=buf[0];
    }else 
	aID=TS_STRING;
    return true;
}

bool BTADInputHelper::checkSubID(BYTE& asubID)
{
    BYTE buf[2];
    if(in->peek(2,buf)!=2)
	return false;

    asubID=buf[1];
    return true;
}

bool BTADInputHelper::readLength(UQBYTE& aLength)
{
    BYTE buf[4];
    UQBYTE length;

    if(in->read(2,buf)!=2)
	return false;
    if(buf[0]==0xff && buf[1]==0xff)
    { // 顼Ȥξ
	in->read(aLength);
    }else{ // ̾糧Ȥξ
	aLength=((UQBYTE)buf[1])*256+buf[0];
    }
    return true;
}

BSegment* BTADInputHelper::getSegment()
{
    BYTE ID;
    BSegment* segment;
    UQBYTE length;

    if(!readID(ID)) // ID Υå
	return NULL;
    if(ID==TS_STRING)
    { // Ĺ(ʸ)ξ
	segment=new BStringSeg();
	if(!(segment->readData(in,0))) // Ȥɤ߹
	{
	    delete segment;
	    return NULL;
	}
	return segment;
    }

    // ĹȤξ
    if(!readLength(length)) // ȤĹΥå
	return NULL;
    if(maker->hasSubID(ID))
    { // sub ID Τ륻Ȥξ
	BYTE subID;
	if(!checkSubID(subID))
	    return NULL;
	segment=maker->make(ID,subID); // Ȥκ
    }else // sub ID ΤʤȤξ
	segment=maker->make(ID); // Ȥκ

    if(segment==NULL)
	return NULL;
    in->resetCount();
    if(!(segment->readData(in,length))) // Ȥɤ߹
    {
	delete segment;
	return NULL;
    }

    if(in->getCount()!=length) // Ȥɤߤξ
	in->skip((int)length-in->getCount()); // ΥȤκǽޤǰư

    return segment;
}
