#include "BTADType.h"
#include "BTADOutputHelper.h"
#include "BSegment.h"
#include "BByteOutputStream.h"
#include "BSegmentMaker.h"
#include "BStringSeg.h"

BTADOutputHelper::BTADOutputHelper(BByteOutputStream* aout):
out(aout)
{
}

bool BTADOutputHelper::writeID(BYTE aID)
{
    if(!out->write(aID))
	return false;

    if(!out->write((BYTE)0xff))
	return false;

    return true;
}


bool BTADOutputHelper::writeLength(UQBYTE alength)
{
    UQBYTE length;

    if(alength < 65534)
    { // ̾糧Ȥξ
	if(!out->write((UDBYTE)alength))
	    return false;
    }else{ // 顼Ȥξ
	if(!out->write((UDBYTE)0xffff))
	    return false;
	if(!out->write((UQBYTE)alength))
	    return false;
    }

    return true;
}

bool BTADOutputHelper::putSegment(const BSegment* asegment)
{
    BYTE ID=asegment->getID();

    UQBYTE length=asegment->getLength();
    if(length%2!=0)
	length++; // ȤĹ϶Τ

    if(ID!=TS_STRING)
    { // ĹȤξ
	if(!writeID(ID)) // ID  0xff 񤭹
	    return false;

	if(!writeLength(length)) // ȤĹ񤭹
	    return false;
    }

    out->resetCount();
    if(!asegment->writeData(out)) // Ȥ񤭹
	return false;

    // 񤭹 Byte Υå
    if(out->getCount() + 1 == length)
	out->write((BYTE)0); // Ǹ碌
    else if(out->getCount() != length)
	return false;

    return true;
}
