#include <fstream.h>
#include "IstreamInputStream.h"
#include "OstreamOutputStream.h"
#include "BInfoSeg.h"
#include "BTextSeg.h"
#include "BFigSeg.h"
#include "BFigPrimLineSeg.h"
#include "BFigPrimPolygonSeg.h"

int main(int argc,char **argv)
{
    if(argc!=3)
    {
	cerr << argv[0] << " input_file output_file" << endl;
	return 1;
    }

    // $B;HMQ$9$k%;%0%a%s%H$NEPO?(B
    BSegMakerRegister<BInfoSeg,TS_INFO>();
    BSegMakerRegister<BTextSeg,TS_TEXT>();
    BSegMakerRegister<BTextEndSeg,TS_TEXTEND>();
    BSegMakerRegister<BFigSeg,TS_FIG>();
    BSegMakerRegister<BFigEndSeg,TS_FIGEND>();
    BSubIDSegMakerRegister<BFigPrimLineSeg,TS_FPRIM,TSS_FPRIMLINE>();
    BSubIDSegMakerRegister<BFigPrimPolygonSeg,TS_FPRIM,TSS_FPRIMPOLYGON>();

    ifstream infile(argv[1],ios::in|ios::binary);
    IstreamTADInputStream in(infile); // $BF~NO%9%H%j!<%`(B

    ofstream outfile(argv[2],ios::out|ios::binary);
    OstreamTADOutputStream out(outfile); // $B=PNO%9%H%j!<%`(B

    vector<BSegment* > TAD; // $B$3$3$KFI$_9~$s$@%;%0%a%s%H$rJ]B8$9$k(B

    while(true)
    {
	BSegment* seg;

	seg=in.getSegment(); // $BF~NO%9%H%j!<%`$+$i%;%0%a%s%H$r(B1$B$DFI$_9~$`(B
	if(seg==NULL) // $B%U%!%$%k$N:G8e$^$GMh$?$i%k!<%W$+$iH4$1$k(B
	    break;

	// ID,sub ID,$B%;%0%a%s%H$N%G!<%?ItJ,$ND9$5$rI=<($9$k(B
	cout << "ID=0x" << hex << (int)seg->getID() << dec <<
	    " subID=" << (int)seg->getSubID() <<
	    " length=" << (int)seg->getLength() <<
	    endl;

	// $B4IM}>pJs%;%0%a%s%H$N>l9g!"%P!<%8%g%s$rI=<($9$k(B
	if(seg->getID()==TS_INFO)
	    cout << "version=0x" << hex << ((BInfoSeg*)seg)->getVersion() <<
		dec << endl;

	TAD.push_back(seg);
    }
    cout << "end." << endl;

    vector<BSegment*>::iterator i;
    for(i=TAD.begin(); i!=TAD.end(); i++)
    {
	if(!out.putSegment(*i)) // $B=PNO%9%H%j!<%`$K=q$-9~$`(B
	{ // $B=q$-9~$a$J$+$C$?>l9g(B
	    cout << "out error" << endl;
	    cout << "ID=0x" << hex << (int)((**i).getID()) << dec <<
		" subID=" << (int)((**i).getSubID()) <<
		" length=" << (int)((**i).getLength()) <<
		endl;
	}
	delete *i;
    }

    return 0;
}
